//////////////////////////////////////////////////////////
// This class has been automatically generated on
// Tue Aug 27 17:53:38 2019 by ROOT version 6.19/01
// from TChain mctree/
//////////////////////////////////////////////////////////

#ifndef BaseReader_h
#define BaseReader_h

#define MAX_TRACKS 20000

#include <TROOT.h>
#include <TChain.h>
#include <TFile.h>
#include <TLorentzVector.h>

// Header file for the classes stored in the TTree if any.

class BaseReader {
public :
   TTree          *fChain;   //!pointer to the analyzed TTree or TChain
   Int_t           fCurrent; //!current Tree number in a TChain

// Fixed size dimensions of array or collections stored in the TTree if any.

   // Declaration of leaf types
   Float_t         bimp;
   Float_t         phi2;
   Float_t         phi3;
   Float_t         ecc2;
   Float_t         ecc3;
   Int_t           npart;
   Int_t           nh;
   Float_t         momx[MAX_TRACKS];   //[nh]
   Float_t         momy[MAX_TRACKS];   //[nh]
   Float_t         momz[MAX_TRACKS];   //[nh]
   Float_t         ene[MAX_TRACKS];   //[nh]
   Int_t           hid[MAX_TRACKS];   //[nh]
   Int_t           pdg[MAX_TRACKS];   //[nh]
   Short_t         charge[MAX_TRACKS];   //[nh]

   // List of branches
   TBranch        *b_bimp;   //!
   TBranch        *b_phi2;   //!
   TBranch        *b_phi3;   //!
   TBranch        *b_ecc2;   //!
   TBranch        *b_ecc3;   //!
   TBranch        *b_npart;   //!
   TBranch        *b_nh;   //!
   TBranch        *b_momx;   //!
   TBranch        *b_momy;   //!
   TBranch        *b_momz;   //!
   TBranch        *b_ene;   //!
   TBranch        *b_hid;   //!
   TBranch        *b_pdg;   //!
   TBranch        *b_charge;   //!

   TLorentzVector *vMom;

   BaseReader(TTree *tree=0);
   virtual ~BaseReader();
   virtual Int_t    Cut(Long64_t entry);
   virtual Int_t    GetEntry(Long64_t entry);
   virtual Long64_t LoadTree(Long64_t entry);
   virtual void     Init(TTree *tree);
   virtual void     Loop();
   virtual Bool_t   Notify();
   virtual void     Show(Long64_t entry = -1);
   virtual Int_t    GetMult(Int_t iEv = -1);
   virtual Int_t    GetMultPHENIX(Int_t iEv = -1);
};

#endif

#ifdef BaseReader_cxx
BaseReader::BaseReader(TTree *tree) : fChain(0) 
{
   vMom = new TLorentzVector();
// if parameter tree is not specified (or zero), connect the file
// used to generate this class and read the Tree.
   if (tree == 0) {

#ifdef SINGLE_TREE
      // The following code should be used if you want this class to access
      // a single tree instead of a chain
      TFile *f = (TFile*)gROOT->GetListOfFiles()->FindObject("Memory Directory");
      if (!f || !f->IsOpen()) {
         f = new TFile("Memory Directory");
      }
      f->GetObject("mctree",tree);

#else // SINGLE_TREE

      // The following code should be used if you want this class to access a chain
      // of trees.
      TChain * chain = new TChain("mctree","");
      chain->Add("/home/peter/Documents/ModelData/run001.root/mctree");
      chain->Add("/home/peter/Documents/ModelData/run002.root/mctree");
      chain->Add("/home/peter/Documents/ModelData/run003.root/mctree");
      chain->Add("/home/peter/Documents/ModelData/run004.root/mctree");
      chain->Add("/home/peter/Documents/ModelData/run005.root/mctree");
      chain->Add("/home/peter/Documents/ModelData/run006.root/mctree");
      chain->Add("/home/peter/Documents/ModelData/run007.root/mctree");
      chain->Add("/home/peter/Documents/ModelData/run008.root/mctree");
      chain->Add("/home/peter/Documents/ModelData/run009.root/mctree");
      chain->Add("/home/peter/Documents/ModelData/run010.root/mctree");
      chain->Add("/home/peter/Documents/ModelData/run011.root/mctree");
      chain->Add("/home/peter/Documents/ModelData/run012.root/mctree");
      chain->Add("/home/peter/Documents/ModelData/run013.root/mctree");
      chain->Add("/home/peter/Documents/ModelData/run014.root/mctree");
      chain->Add("/home/peter/Documents/ModelData/run015.root/mctree");
      chain->Add("/home/peter/Documents/ModelData/run016.root/mctree");
      chain->Add("/home/peter/Documents/ModelData/run017.root/mctree");
      chain->Add("/home/peter/Documents/ModelData/run018.root/mctree");
      chain->Add("/home/peter/Documents/ModelData/run019.root/mctree");
      chain->Add("/home/peter/Documents/ModelData/run020.root/mctree");
      chain->Add("/home/peter/Documents/ModelData/run021.root/mctree");
      chain->Add("/home/peter/Documents/ModelData/run022.root/mctree");
      chain->Add("/home/peter/Documents/ModelData/run023.root/mctree");
      chain->Add("/home/peter/Documents/ModelData/run024.root/mctree");
      chain->Add("/home/peter/Documents/ModelData/run025.root/mctree");
      chain->Add("/home/peter/Documents/ModelData/run026.root/mctree");
      chain->Add("/home/peter/Documents/ModelData/run027.root/mctree");
      chain->Add("/home/peter/Documents/ModelData/run028.root/mctree");
      chain->Add("/home/peter/Documents/ModelData/run029.root/mctree");
      chain->Add("/home/peter/Documents/ModelData/run030.root/mctree");
      chain->Add("/home/peter/Documents/ModelData/run031.root/mctree");
      chain->Add("/home/peter/Documents/ModelData/run032.root/mctree");
      chain->Add("/home/peter/Documents/ModelData/run033.root/mctree");
      chain->Add("/home/peter/Documents/ModelData/run034.root/mctree");
      chain->Add("/home/peter/Documents/ModelData/run035.root/mctree");
      chain->Add("/home/peter/Documents/ModelData/run036.root/mctree");
      chain->Add("/home/peter/Documents/ModelData/run037.root/mctree");
      chain->Add("/home/peter/Documents/ModelData/run038.root/mctree");
      chain->Add("/home/peter/Documents/ModelData/run039.root/mctree");
      tree = chain;
#endif // SINGLE_TREE

   }
   Init(tree);
}

BaseReader::~BaseReader()
{
   if (!fChain) return;
   delete fChain->GetCurrentFile();
   delete vMom;
}

Int_t BaseReader::GetEntry(Long64_t entry)
{
// Read contents of entry.
   if (!fChain) return 0;
   return fChain->GetEntry(entry);
}
Long64_t BaseReader::LoadTree(Long64_t entry)
{
// Set the environment to read one entry
   if (!fChain) return -5;
   Long64_t centry = fChain->LoadTree(entry);
   if (centry < 0) return centry;
   if (fChain->GetTreeNumber() != fCurrent) {
      fCurrent = fChain->GetTreeNumber();
      Notify();
   }
   return centry;
}

void BaseReader::Init(TTree *tree)
{
   // The Init() function is called when the selector needs to initialize
   // a new tree or chain. Typically here the branch addresses and branch
   // pointers of the tree will be set.
   // It is normally not necessary to make changes to the generated
   // code, but the routine can be extended by the user if needed.
   // Init() will be called many times when running on PROOF
   // (once per file to be processed).

   // Set branch addresses and branch pointers
   if (!tree) return;
   fChain = tree;
   fCurrent = -1;
   fChain->SetMakeClass(1);

   fChain->SetBranchAddress("bimp", &bimp, &b_bimp);
   fChain->SetBranchAddress("phi2", &phi2, &b_phi2);
   fChain->SetBranchAddress("phi3", &phi3, &b_phi3);
   fChain->SetBranchAddress("ecc2", &ecc2, &b_ecc2);
   fChain->SetBranchAddress("ecc3", &ecc3, &b_ecc3);
   fChain->SetBranchAddress("npart", &npart, &b_npart);
   fChain->SetBranchAddress("nh", &nh, &b_nh);
   fChain->SetBranchAddress("momx", momx, &b_momx);
   fChain->SetBranchAddress("momy", momy, &b_momy);
   fChain->SetBranchAddress("momz", momz, &b_momz);
   fChain->SetBranchAddress("ene", ene, &b_ene);
   fChain->SetBranchAddress("hid", hid, &b_hid);
   fChain->SetBranchAddress("pdg", pdg, &b_pdg);
   fChain->SetBranchAddress("charge", charge, &b_charge);
   Notify();
}

Bool_t BaseReader::Notify()
{
   // The Notify() function is called when a new file is opened. This
   // can be either for a new TTree in a TChain or when when a new TTree
   // is started when using PROOF. It is normally not necessary to make changes
   // to the generated code, but the routine can be extended by the
   // user if needed. The return value is currently not used.

   return kTRUE;
}

void BaseReader::Show(Long64_t entry)
{
// Print contents of entry.
// If entry is not specified, print current entry
   if (!fChain) return;
   fChain->Show(entry);
}
Int_t BaseReader::Cut(Long64_t entry)
{
// This function may be called from Loop.
// returns  1 if entry is accepted.
// returns -1 otherwise.
   return 1;
}
#endif // #ifdef BaseReader_cxx
