#include <iostream>

#include "../Flow/FlowCalculator.cxx"

#include <TROOT.h>
#include <TFile.h>
#include <TH1F.h>
#include <TChain.h>

void calculateFlow(TString chainName, TString refMultFileName, TString resFileName, TString outName)
{
  TChain *chain = new TChain("mctree");
  //chain->Add("/home/peter/Documents/ModelData/run*.root");
  //chain->Add("/mnt/pool/nica/6/arkadij/mcpico/phsd200gev/run0[5-9]*.root");
  //chain->Add("/mnt/pool/nica/6/arkadij/mcpico/phsd200charge/m200*CHrun0[0-4]*.root");
  chain->Add(chainName.Data());

  FlowCalculator *flow = new FlowCalculator(chain);
  flow->RotateRP();
  flow->SetRefMultHistName("hMultPHENIX");
  flow->InitCentFile(refMultFileName.Data());
  flow->InitResFile(resFileName);
  flow->LoopFlow(outName);

	std::cout << "Done!" << std::endl;
}
