#include "../Centrality/CentralityCalculator.cxx"

#include <TROOT.h>
#include <TFile.h>
#include <TH1F.h>

void drawCentrality(TString refMultFileName, TString outCanvasName)
{
  gROOT->SetStyle("Pub");
  TFile *file = new TFile(refMultFileName.Data(),"read");
  TH1F  *hist = (TH1F*) file->Get("hMultPHENIX");

  CentralityCalculator *cent = new CentralityCalculator();
  cent->SetHistogram(hist);
  cent->SetEnergy(200);
  cent->SetModel("PHSD");
  cent->SetEfficiency(0.93);

  cent->Calc();
  cent->DrawHistogram(outCanvasName);
}